##
##  sccs.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2025 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_sccs  070527
%define       V_cssc  1.0.1

#   package information
Name:         sccs
Summary:      Source Code Control System (SCCS)
URL:          http://heirloom.sourceforge.net/devtools.html
Vendor:       Sun, Gunnar Ritter et al.
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        SCM
License:      BSD/CDDL & GPL
Version:      %{V_sccs}
Release:      20110428

#   list of sources
Source0:      http://download.sourceforge.net/heirloom/heirloom-devtools-%{V_sccs}.tar.bz2
Source1:      http://download.sourceforge.net/cssc/CSSC-%{V_cssc}.tar.gz
Patch0:       sccs.patch

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, gcc, gcc::with_cxx = yes, make
PreReq:       OpenPKG, openpkg >= 20160101

%description
    This is the Unix Source Code Control System (SCCS). It is provided
    by the Heirloom Development Tools package, which in turn contains a
    portable derivative of the SCCS utilities released by Sun as part
    of OpenSolaris. The OpenSolaris utilities were in turn derived
    from the original Unix versions, and are assumed be conforming
    implementations of the POSIX standard. Additionally, the GNU CSSC
    clone of SCCS is provided in this package, too.

%track
    prog sccs:sccs = {
        version   = %{V_sccs}
        url       = http://sourceforge.net/projects/heirloom/files/
        regex     = heirloom-devtools-(__VER__)\.tar\.bz2
    }
    prog sccs:cssc = {
        version   = %{V_cssc}
        url       = http://sourceforge.net/projects/cssc/files/
        regex     = CSSC-(\d+\.\d+\.\d+)\.tar\.gz
    }

%prep
    %setup -q -c
    %setup -q -D -T -a 1
    %patch -p0 -d heirloom-devtools-%{V_sccs}

%build
    #   build Heirloom SCCS
    (   cd heirloom-devtools-%{V_sccs}
        %{l_make} %{l_mflags} \
            SUBDIRS="sccs/cassi sccs/comobj sccs/mpwlib sccs/src sccs/help.d sccs/man" \
            CC="%{l_cc}" \
            CFLAGS="%{l_cflags -O}" \
            BINDIR=%{l_prefix}/libexec/sccs/sccs \
            LIBDIR=%{l_prefix}/lib/sccs \
            MANDIR=%{l_prefix}/man
    ) || exit $?

    #   build GNU CSSC
    (   cd CSSC-%{V_cssc}
        CC="%{l_cc}" \
        CFLAGS="%{l_cflags -O}" \
        ./configure \
            --prefix=%{l_prefix} \
            --libexecdir=%{l_prefix}/libexec/sccs \
            --enable-binary
        %{l_make} %{l_mflags}
    ) || exit $?

%install
    #   install GNU CSSC
    (   cd CSSC-%{V_cssc}
        %{l_make} %{l_mflags} install AM_MAKEFLAGS="DESTDIR=$RPM_BUILD_ROOT"
    ) || exit $?

    #   consistently use "cssc" for GNU CSSC
    mv  $RPM_BUILD_ROOT%{l_prefix}/bin/sccs \
        $RPM_BUILD_ROOT%{l_prefix}/bin/cssc
    mv  $RPM_BUILD_ROOT%{l_prefix}/man/man1/sccs.1 \
        $RPM_BUILD_ROOT%{l_prefix}/man/man1/cssc.1

    #   install Heirloom SCCS
    (   cd heirloom-devtools-%{V_sccs}
        %{l_make} %{l_mflags} install \
            SUBDIRS="sccs/cassi sccs/comobj sccs/mpwlib sccs/src sccs/help.d sccs/man" \
            ROOT=$RPM_BUILD_ROOT \
            BINDIR=%{l_prefix}/libexec/sccs/sccs \
            LIBDIR=%{l_prefix}/lib/sccs \
            MANDIR=%{l_prefix}/man \
            INSTALL="%{l_shtool} install"
    ) || exit $?

    #   move Heirloom SCCS frontend command into path
    mv  $RPM_BUILD_ROOT%{l_prefix}/libexec/sccs/sccs/sccs \
        $RPM_BUILD_ROOT%{l_prefix}/bin/sccs

    #   strip down installation
    strip $RPM_BUILD_ROOT%{l_prefix}/libexec/sccs/*/* 2>/dev/null || true
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* 2>/dev/null || true
    rm -f $RPM_BUILD_ROOT%{l_prefix}/info/dir

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

